<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">考勤管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/base/workSchedule">班次考勤设置</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form
      ref="queryForm"
      :model="queryModel"
      inline
      class="demo-form-inline"
    >
    <el-form-item label="单位名称" prop="companyId">
        <el-select-tree
          size="mini"
          :props="companyProps"
          :options="companyResult"
          v-model="queryModel.companyId"
          height="200"
        ></el-select-tree>
      </el-form-item>
      <el-form-item label="班次名称" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
          >查询</el-button
        >&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
          >重置</el-button
        >&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        @click="handleAdd"
        >新增</el-button
      >
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        :disabled="multipleSelection.length == 0"
        @click="handleBatchDelete"
        >删除选中项</el-button
      >
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-edit"
        :loading="loading"
        @click="handleBatchUpdate"
        v-show="batchUpdateVisible"
      >重新生成考勤数据</el-button>
    </el-row>
    <el-table
      :data="tableData"
      style="min-height: 400px"
      v-loading="loading"
      stripe
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column
        prop="companyName"
        label="单位名称"
        width="220"
      ></el-table-column>
      <el-table-column
        prop="name"
        label="班次名称"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="weekdays"
        label="周工作日"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="startTime"
        label="上班时间"
        width="120"
      ></el-table-column>
      <el-table-column
        prop="startAdvanceMinutes"
        label="上班提前分钟"
        width="120"
      ></el-table-column>
      <el-table-column
        prop="startDelayMinutes"
        label="上班延迟分钟"
        width="120"
      ></el-table-column>
      <el-table-column
        prop="endTime"
        label="下班时间"
        width="120"
      ></el-table-column>
      <el-table-column
        prop="endAdvanceMinutes"
        label="下班提前分钟"
        width="120"
      ></el-table-column>
      <el-table-column
        prop="endDelayMinutes"
        label="下班延迟分钟"
        width="120"
      ></el-table-column>
      <el-table-column label="操作" width="250" fixed="right">
        <template slot-scope="{ row }">
          <el-button size="mini" type="warning" @click="handleEdit(row)"
            >编辑</el-button
          >
          <el-button size="mini" type="primary" @click="handleCompany(row)"
            >关联部门</el-button
          >
          <el-button size="mini" type="danger" @click="handleDelete(row)"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <workSchedule-detail
      v-if="showModal"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></workSchedule-detail>
    <workSchedule-company
      v-if="showModal1"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></workSchedule-company>
    <workSchedule-update
      v-if="showModal2"
      title="更新考勤记录"
      :multipleSelection="multipleSelection"
      @close="showModal2=false"
    ></workSchedule-update>
  </div>
</template>
<script>
import Constant from "@/constant";
import WorkScheduleDetail from "./workSchedule-detail";
import WorkScheduleCompany from "./workSchedule-company";
import WorkScheduleUpdate from "./workSchedule-update";
import workScheduleApi from "@/api/base/workSchedule";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style
import companyInfoApi from "@/api/base/companyInfo";
import SelectTree from "@/components/SelectTree";
import permissionApi from "@/api/sys/permission";

export default {
  name: "baseWorkScheduleList",
  data() {
    var self = this;

    return {
      queryModel: {
        id: "",
        name: "",
        weekdays: "",
        startType: "",
        startTime: "",
        startAdvanceMinutes: "",
        startDelayMinutes: "",
        endType: "",
        endTime: "",
        endAdvanceMinutes: "",
        endDelayMinutes: "",
        companyId: "",
        createBy: "",
        createTime: "",
        updateBy: "",
        updateTime: "",
        delFlag: "",
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      showModal1: false,
      modalTitle: "",
      businessKey: "",
      companyResult: [],
      companyProps: {
        value: "id",
        label: "name",
        children: "children"
      },
      batchUpdateVisible: false,
      showModal2: false
    };
  },
  created() {
    var self = this;

    companyInfoApi.list().then(function(response) {
      var jsonData = response.data;
      if (jsonData.result) {
        self.companyResult = jsonData.data;
      }
    });

    permissionApi.hasPermission("post","/business/workScheduleReport/batchUpdate")
    .then(response=>{
      this.batchUpdateVisible = response.data.result;
    });
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("name", self.queryModel.name);
      formData.append("companyId", self.queryModel.companyId);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      workScheduleApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleCompany(record) {
      this.modalTitle = "部门";
      this.businessKey = record.id;
      this.showModal1 = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          workScheduleApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        workScheduleApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;
      this.showModal1 = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },    
    handleBatchUpdate() {
      var self = this;

      if(this.multipleSelection.length==0){
        self.$message.warning("请先选择考勤班次!");
        return;
      }

      this.showModal2 = true;
    }
  },
  mounted: function () {
    this.changePage(1);
  },
  components: {
    "workSchedule-detail": WorkScheduleDetail,
    "workSchedule-company": WorkScheduleCompany,
    "workSchedule-update": WorkScheduleUpdate,
    "el-select-tree": SelectTree
  },
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>